function toLODs(resolution_0, dpi, level, isDegree) {
  var lods = [],
    i = 0,
    r = resolution_0,
    s = (r * dpi) / 0.0254;
  s = (r * dpi) / 0.02687999999999999793948033361118;
  // isDegree === true && (s *= 111194.872221777);
  isDegree === true && (s *= 111319.49079327358);

  while (i < level) {
    i > 0 && ((r /= 2), (s /= 2));
    lods.push({ level: i, resolution: r, scale: s });
    i++;
  }
  return lods;
}

function getTilemeta(
  resolution_0,
  dpi,
  level,
  levelStart,
  wkid,
  fullExtent,
  origin,
  tileSize,
  format,
  unit,
) {
  return {
    copyrightText: '熊猫智慧水务',
    description: '',
    documentInfo: {
      Title: null,
      Author: null,
      Comments: null,
      Subject: null,
      Category: null,
      Keywords: null,
    },
    fullExtent: {
      spatialReference: {
        wkid: wkid,
      },
      xmin: fullExtent[0],
      ymin: fullExtent[1],
      xmax: fullExtent[2],
      ymax: fullExtent[3],
    },
    hasVersionedData: false,
    hasAnnotation: false,
    initialExtent: {
      spatialReference: {
        wkid: wkid,
      },
      xmin: fullExtent[0],
      ymin: fullExtent[1],
      xmax: fullExtent[2],
      ymax: fullExtent[3],
    },
    layers: null,
    mapName: 'tianditutile',
    minScale: 0,
    maxScale: 0,
    serviceDescription: null,
    singleFusedMapCache: false,
    spatialReference: {
      wkid: wkid,
    },
    supportsDynamicLayers: false,
    tileInfo: {
      dpi: dpi,
      format: format,
      rows: tileSize,
      cols: tileSize,
      lods: toLODs(resolution_0, dpi, level, unit).slice(levelStart),
      origin: origin,
      spatialReference: {
        wkid: wkid,
      },
    },
    units: 'meters',
    currentVersion: 10.3,
    capabilities: null,
  };
}

export default { toLODs, getTilemeta };
